package ca.uwaterloo.cs.jgrok.io;

import java.io.*;
import java.util.Enumeration;

import ca.uwaterloo.cs.jgrok.fb.*;

public class RSFFileWriter implements FactbaseWriter {
    
    public RSFFileWriter() {}
    
    public void write(String fileName, Factbase factbase) throws IOException {
        File file;
        
        file = new File(fileName);
        if(!file.exists()) {
            file.createNewFile();
        } else {
            if(file.isDirectory()) {
                throw new IOException("File " + fileName + " is a directory");
            }
        }
        
        FileOutputStream fileOut;
        fileOut = new FileOutputStream(file);
        
        Enumeration<TupleSet> enm1 = factbase.allSets();
        while(enm1.hasMoreElements()) {
            TupleSet set = enm1.nextElement();
            if(!set.getName().startsWith("@"))
                set.printTA(fileOut);
        }
        
        Enumeration<EdgeSet> enm2 = factbase.allEdgeSets();
        while(enm2.hasMoreElements()) {
            EdgeSet eset = enm2.nextElement();
            if(eset.getName().startsWith("@"))
                eset.printRSF(fileOut);
        }
    }

}
