package ca.uwaterloo.cs.jgrok.io;

import java.io.*;
import java.util.Enumeration;

import ca.uwaterloo.cs.jgrok.fb.EdgeSet;
import ca.uwaterloo.cs.jgrok.fb.TupleSet;
import ca.uwaterloo.cs.jgrok.fb.Factbase;

public class TAFileWriter implements FactbaseWriter {
    
    public TAFileWriter() {}
    
    public void write(String fileName, Factbase factbase) throws IOException {
        File file;
        
        file = new File(fileName);
        if(!file.exists()) {
            file.createNewFile();
        } else {
            if(file.isDirectory()) {
                throw new IOException("File " + fileName + " is a directory");
            }
        }
        
        PrintWriter writer;
        FileOutputStream fileOut;
        
        fileOut = new FileOutputStream(file);
        writer = new PrintWriter(fileOut);
        writer.println("FACT TUPLE :");
        writer.flush();
        
        Enumeration<TupleSet> enm1 = factbase.allSets();
        while(enm1.hasMoreElements()) {
            TupleSet set = enm1.nextElement();
            if(!set.getName().startsWith("@"))
                set.printTA(fileOut);
        }
        
        writer.println("FACT ATTRIBUTE :");
        writer.flush();

        Enumeration<EdgeSet> enm2 = factbase.allEdgeSets();
        while(enm2.hasMoreElements()) {
            EdgeSet eset = enm2.nextElement();
            if(eset.getName().startsWith("@"))
                eset.printTA(fileOut);
        }
        
        writer.close();
    }
}
