package ca.uwaterloo.cs.jgrok.lib;

import ca.uwaterloo.cs.jgrok.env.Env;
import ca.uwaterloo.cs.jgrok.interp.*;

/**
 * <pre>
 *     int   int(int/float/string)
 *     float float(int/float/string)
 * </pre>
 */
public class Cast extends Function {
    
    public Cast() {
        name = "int";
        type = int.class;
        paramTypes = new Class[1];
        paramTypes[0] = String.class;
    }
        
    public Value invoke(Env env, Value[] vals)
        throws InvocationException {
        Value val = vals[0];
        Class<?> valType = val.getType();
        
        if(name.equals("int")) {
            if(valType == int.class) {
                return new Value(val.intValue());
            } else if(valType == float.class) {
                return new Value((int)val.floatValue());
            } else {
                try {
                    float f = Float.parseFloat(val.toString());
                    return new Value((int)f);
                } catch(Exception e) {
                    throw new InvocationException(e.getMessage());
                }
            }
        } else {
            if(valType == int.class) {
                return new Value((float)val.intValue());
            } else if(valType == float.class) {
                return new Value(val.floatValue());
            } else {
                try {
                    float f = Float.parseFloat(val.toString());
                    return new Value(f);
                } catch(Exception e) {
                    throw new InvocationException(e.getMessage());
                }
            }
        }
    }
}
