package ca.uwaterloo.cs.jgrok.lib;

import ca.uwaterloo.cs.jgrok.env.Env;
import ca.uwaterloo.cs.jgrok.fb.ConceptEngine;
import ca.uwaterloo.cs.jgrok.fb.EdgeSet;
import ca.uwaterloo.cs.jgrok.fb.NodeSet;
import ca.uwaterloo.cs.jgrok.fb.SpecialOperation;
import ca.uwaterloo.cs.jgrok.interp.Value;

/**
 * <pre>
 *     EdgeSet concept(EdgeSet)
 *     EdgeSet lattice(NodeSet)
 * </pre>
 */
public class ConceptLattice extends Function {
    
    public ConceptLattice() {
        name = "lattice";
        type = EdgeSet.class;
        paramTypes = new Class[1];
        paramTypes[0] = NodeSet.class;
    }
    
    public Value invoke(Env env, Value[] vals)
        throws InvocationException {
        
        if(getName().equals("lattice")) {
            NodeSet set = (NodeSet)vals[0].objectValue();
            
            return new Value(SpecialOperation.lattice(set));
        } else if(getName().equals("concept")) {
            EdgeSet hasFeature = (EdgeSet)vals[0].objectValue();
            ConceptEngine engine = new ConceptEngine();
            engine.compute(hasFeature);
            
            return new Value(engine.getConcepts());
        } else {
            throw InvocationException.createUnknownFunction(getName());
        }
    }
}
