package ca.uwaterloo.cs.jgrok.lib;

import ca.uwaterloo.cs.jgrok.env.Env;
import ca.uwaterloo.cs.jgrok.fb.*;
import ca.uwaterloo.cs.jgrok.interp.Value;

/**
 * <pre>
 *     tset head(tset)
 *     tset head(tset, int)
 * </pre>
 */
public class Head extends Function {
    
    public Head() {
        name = "head";
        type = TupleSet.class;
        paramTypes = new Class[1];
        paramTypes[0] = TupleSet.class;
    }
    
    public Value invoke(Env env, Value[] vals)
        throws InvocationException {
        int count;
        TupleSet input;
        TupleSet output;
        TupleList tList;

        input = (TupleSet)vals[0].objectValue();
        tList = input.getTupleList();
        
        if(vals.length == 1) count = 10;
        else count = vals[1].intValue();

        output = input.newSet();        
        count = (count < tList.size()) ? count : tList.size();
        for(int i = 0; i < count; i++) {
            output.add((Tuple)tList.get(i).clone());
        }
        
        return new Value(output);
    }
}
