package ca.uwaterloo.cs.jgrok.lib;

import ca.uwaterloo.cs.jgrok.env.Env;
import ca.uwaterloo.cs.jgrok.fb.*;
import ca.uwaterloo.cs.jgrok.interp.Value;

/**
 * <pre>
 *     tset rand(tset)
 *     tset rand(tset, int)
 * </pre>
 */
public class Rand extends Function {
    
    public Rand() {
        name = "rand";
        type = TupleSet.class;
        paramTypes = new Class[1];
        paramTypes[0] = TupleSet.class;
    }
    
    public Value invoke(Env env, Value[] vals)
        throws InvocationException {
        int count;
        TupleSet input;
        TupleSet output;
        TupleList tList;
        
        input = (TupleSet)vals[0].objectValue();
        tList = input.getTupleList();
        output = input.newSet();
        
        if(vals.length == 1) count = 10;
        else count = vals[1].intValue();
        
        int size = tList.size();
        if(count < 1) return new Value(output);
        if(count >= size) return new Value(input.clone());
        
        int step;
        int index;
        boolean b = false;
        
        step = size / count;
        if(step == 1) {
            b = true;
            count = size - count;
            step = size / count;
        }
        
        for(int i = 0; i < count; i++) {
            index = i * step + (int)(Math.random() * step);
            output.add((Tuple)tList.get(index).clone());
        }
        
        if(b) output = AlgebraOperation.difference(input, output);
        return new Value(output);
    }
}
