package ca.uwaterloo.cs.jgrok.lib;

import ca.uwaterloo.cs.jgrok.env.Env;
import ca.uwaterloo.cs.jgrok.fb.*;
import ca.uwaterloo.cs.jgrok.interp.*;

/**
 * <pre>
 *      EdgeSet reach(string  startNode,  EdgeSet edges)
 *      EdgeSet reach(NodeSet startNodes, EdgeSet edges)
 *      EdgeSet reach(NodeSet startNodes, NodeSet endNodes, EdgeSet edges)
 * </pre>
 */
public class Reach extends Function {
    
    public Reach() {
        name = "reach";
        type = EdgeSet.class;
        paramTypes = new Class[2];
        paramTypes[0] = String.class;
        paramTypes[1] = EdgeSet.class;
    }
    
    public Value invoke(Env env, Value[] vals)
        throws InvocationException {
        Object o;
        EdgeSet eSet;
        EdgeSet result;
        
        if(vals.length == 2) {
            o = vals[0].objectValue();
            
            NodeSet set;
            if(o instanceof NodeSet) {
                set = (NodeSet)o;
            } else {
                set = NodeSet.singleton((String)o);
            }
            
            eSet = (EdgeSet)vals[1].objectValue();
            result = UtilityOperation.reach(set, eSet);
        } else {
            NodeSet srcSet;
            NodeSet sinkSet;
            
            srcSet  = (NodeSet)vals[0].objectValue();
            sinkSet = (NodeSet)vals[1].objectValue();
            eSet = (EdgeSet)vals[2].objectValue();
            result = UtilityOperation.reach(srcSet, sinkSet, eSet);
        }
        
        return new Value(result);
    }
}
