package ca.uwaterloo.cs.jgrok.lib;

import java.util.Enumeration;

import ca.uwaterloo.cs.jgrok.env.Env;
import ca.uwaterloo.cs.jgrok.fb.*;
import ca.uwaterloo.cs.jgrok.interp.*;

/**
 * <pre>
 * Functions:
 *
 *     void replaceid(eset)
 *     mset replaceid(mset, eset)
 *
 * </pre>
 */
public class ReplaceIdentifier extends Function {
    
    public ReplaceIdentifier() {
        name = "replaceid";
        type = void.class;
        paramTypes = new Class[1];
        paramTypes[0] = EdgeSet.class;
    }
    
    public Value invoke(Env env, Value[] vals)
        throws InvocationException {
        EdgeSet pairIDs;
        
        if(vals.length == 1) {
            Scope scp = env.peepScope();
            Enumeration<Variable> enm = scp.allVariables();
            
            pairIDs = (EdgeSet)vals[0].objectValue();
            ReplaceID.init(pairIDs);
            
            Object o;
            TupleSet m;
            Variable var;
            while(enm.hasMoreElements()) {
                var = enm.nextElement();
                o = var.getValue().objectValue();
                if(o instanceof TupleSet) {
                    m = (TupleSet)o;
                    ReplaceID.process(m);
                    m.removeDuplicates();
                }
            }
            
            ReplaceID.close();
            
            return Value.VOID;
        } else {
            TupleSet m;
            m = (TupleSet)vals[0].objectValue();
            m = (TupleSet)m.clone();
            
            pairIDs = (EdgeSet)vals[1].objectValue();
            ReplaceID.init(pairIDs);
            
            ReplaceID.process(m);
            m.removeDuplicates();
            
            ReplaceID.close();
            
            return new Value(m);
        }
    }
}
