package ca.uwaterloo.cs.jgrok.lib;

import ca.uwaterloo.cs.jgrok.env.Env;
import ca.uwaterloo.cs.jgrok.fb.*;
import ca.uwaterloo.cs.jgrok.interp.*;

/**
 * showpath(string source, string target, EdgeSet edgeSet)
 */
public class ShowPath extends Function {
    
    public ShowPath() {
        name = "showpath";
        type = void.class;
        paramTypes = new Class[3];
        paramTypes[0] = String.class;
        paramTypes[1] = String.class;
        paramTypes[2] = EdgeSet.class;
    }
    
    public Value invoke(Env env, Value[] vals)
        throws InvocationException {
        String source = vals[0].toString();
        String target = vals[1].toString();
        EdgeSet eSet = (EdgeSet)vals[2].objectValue();
        
        eSet = UtilityOperation.reach(NodeSet.singleton(source),
                                      NodeSet.singleton(target),
                                      eSet);
        
        PathClosure pc = new PathClosure(eSet);
        Path[] paths = pc.getPaths(source, target);
        
        for(int i = 0; i < paths.length; i++) {
            env.out.println(paths[i]);
        }
        
        return Value.VOID;
    }
}
