package ca.uwaterloo.cs.jgrok.lib.math;

import ca.uwaterloo.cs.jgrok.env.Env;
import ca.uwaterloo.cs.jgrok.interp.*;
import ca.uwaterloo.cs.jgrok.lib.Function;
import ca.uwaterloo.cs.jgrok.lib.InvocationException;

/**
 * <pre>
 *     float pow(int, int);
 *     float pow(int, float);
 *
 *     float pow(float, int);
 *     float pow(float, float);
 * </pre>
 */
public class Pow extends Function {
    
    public Pow() {
        name = "pow";
        type = float.class;
        paramTypes = new Class[2];
        paramTypes[0] = int.class;
        paramTypes[1] = int.class;
    }
    
    public Value invoke(Env env, Value[] vals)
        throws InvocationException {
        
        try {
            double base = (double)vals[0].floatValue();
            double power = (double)vals[1].floatValue();
            return new Value((float)Math.pow(base, power));
        } catch(Exception e) {
            throw new InvocationException(e.getMessage());
        }
    }
}
